import { ClipboardService } from './clipboard.service';
import { EventEmitter, OnDestroy, OnInit, Renderer } from '@angular/core';
export declare class ClipboardDirective implements OnInit, OnDestroy {
    private clipboardSrv;
    private renderer;
    targetElm: HTMLInputElement;
    cbContent: string;
    cbOnSuccess: EventEmitter<any>;
    cbOnError: EventEmitter<any>;
    /**
     * @param {?} clipboardSrv
     * @param {?} renderer
     */
    constructor(clipboardSrv: ClipboardService, renderer: Renderer);
    /**
     * @return {?}
     */
    ngOnInit(): void;
    /**
     * @return {?}
     */
    ngOnDestroy(): void;
    /**
     * @param {?} button
     * @return {?}
     */
    private onClick(button);
    /**
     * Fires an event based on the copy operation result.
    \@param {Boolean} succeeded
     * @param {?} succeeded
     * @param {?} copiedContent
     * @return {?}
     */
    private handleResult(succeeded, copiedContent);
}
