import { WindowSrv } from './window.service';
import { Optional, Renderer, OpaqueToken } from '@angular/core';
export declare class ClipboardService {
    private document;
    private windowService;
    private tempTextArea;
    private window;
    /**
     * @param {?} document
     * @param {?} windowService
     */
    constructor(document: Document, windowService: WindowSrv);
    /**
     * @return {?}
     */
    readonly isSupported: boolean;
    /**
     * @param {?} element
     * @return {?}
     */
    isTargetValid(element: HTMLInputElement | HTMLTextAreaElement): boolean;
    /**
     * copyFromInputElement
     * @param {?} targetElm
     * @param {?} renderer
     * @return {?}
     */
    copyFromInputElement(targetElm: HTMLInputElement | HTMLTextAreaElement, renderer: Renderer): boolean;
    /**
     * Creates a fake textarea element, sets its value from `text` property,
    and makes a selection on it.
     * @param {?} content
     * @param {?} renderer
     * @return {?}
     */
    copyFromContent(content: string, renderer: Renderer): boolean;
    /**
     * @return {?}
     */
    destroy(): void;
    /**
     * @param {?} inputElement
     * @param {?} renderer
     * @return {?}
     */
    private selectTarget(inputElement, renderer);
    /**
     * @return {?}
     */
    private copyText();
    /**
     * @param {?} inputElement
     * @param {?} window
     * @return {?}
     */
    private clearSelection(inputElement, window);
    /**
     * @param {?} doc
     * @param {?} window
     * @return {?}
     */
    private createTempTextArea(doc, window);
}
/**
 * @param {?} doc
 * @param {?} windowSrv
 * @param {?} parentDispatcher
 * @return {?}
 */
export declare function CLIPBOARD_SERVICE_PROVIDER_FACTORY(doc: any, windowSrv: WindowSrv, parentDispatcher: ClipboardService): ClipboardService;
export declare const CLIPBOARD_SERVICE_PROVIDER: {
    provide: typeof ClipboardService;
    useFactory: (doc: any, windowSrv: WindowSrv, parentDispatcher: ClipboardService) => ClipboardService;
    deps: (typeof WindowSrv | OpaqueToken | Optional[])[];
};
